﻿namespace UltraGridMergeCells
{
    using System;
    using System.Data;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            this.Load += Form1_Load;
            this.ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //  Add some dummy data to the grid
            var data = this.GetData();
            this.ultraGrid1.SetDataBinding(data, data.TableName);

            //  Set the grid's DrawFilter allowing us to draw the text in vertical direction
            this.ultraGrid1.DrawFilter = new DF();
        }

        private void UltraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            //  Set merged cell style property to force the grid to merge the cells across rows.
            e.Layout.Bands[0].Columns[0].MergedCellStyle = MergedCellStyle.Always;
        }

        private DataTable GetData(int rows = 20, int cols = 5)
        {
            DataTable dt = new DataTable();

            for(int col = 0; col < cols; col++)
            {
                dt.Columns.Add(string.Format("Column #{0}", col + 1));
            }

            for(int row = 0; row < rows; row++)
            {
                DataRow addRow = dt.NewRow();
                foreach(DataColumn column in dt.Columns)
                {
                    if(column.Ordinal == 0)
                    {
                        addRow[column] = string.Format("{0}.{1}", (row + 1) / 4, column.Ordinal + 1);
                    }
                    else
                    {
                        addRow[column] = string.Format("{0}.{1}", row + 1, column.Ordinal + 1);
                    }
                }

                dt.Rows.Add(addRow);
            }

            return dt;
        }
    }
}
